<?php
// ------------------------------------------------------------------------- //
//                           Agendax-X for Xoops                             //
//                              Version:  2.0                                //
// ------------------------------------------------------------------------- //
// Author: Wang Jue (alias wjue)                                             //
// Purpose: Very Flexible Calendar and Event Module                          //
// email: wjue@wjue.org                                                      //
// URLs: http://www.China-Offshore.com,  http://www.guanxiCRM.com                      //
//---------------------------------------------------------------------------//
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//---------------------------------------------------------------------------//

require "config.inc.php";

define("AGENDAX_SHOW_BRIEF", 0);
define("AGENDAX_SHOW_COMPLET", 1);
//define("AGENDAX_SHOW_MONTHLY_CALENDAR", 2);

$ONE_DAY = 86400;
// how many days in a month (regular and leap year)
$days_per_month = array ( 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 );
$ldays_per_month = array ( 0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 );

#agendax internationalization
$gettext_php_domain = 'agendax';
$gettext_php_dir = $agendax_path.'/locale';


#group permission constants
define("AGENDAX_PERM_SUBMIT", 1);
define("AGENDAX_PERM_EDITDELETE_EVENTS", 2);
define("AGENDAX_PERM_MANAGE_CATEGORIES", 4);
define("AGENDAX_PERM_APPROVE", 8);
define("AGENDAX_PERM_VIEW_OTHERS_EVENTS", 16);


require('./i18n.php');

//$agendax_language = _LANGCODE; //to force a language (_LANGCODE: language_used_in_Xoops)/global.php
//set_up_language('en_US', false); 
set_up_language(); 

$xoops_module_header ="<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" href=\""."$agendax_url/templates/style.css\" />\n";

if (($agendax_language == 'zh_TW')||($agendax_language == 'zh_CN')) {
    $dateSuffix['nian'] = _("Year");
    $dateSuffix['ri']   = _("Day");
} else {
    $dateSuffix['nian'] = '';
    $dateSuffix['ri']   = '';
}

// UserTimestamp so no problem for Time zone if user is logged in
$userTimestamp = xoops_getUserTimestamp(time());

/**
  * some settings of vars
  */
if (!isset($_GET['op']))  $op = ''; else $op = $_GET['op'];
if (!isset($_GET['kdate']))  $kdate = date("Ymd", $userTimestamp); else $kdate = $_GET['kdate']; //format yyyymmdd
if (!isset($_GET['date'])) $date = ''; else $date = $_GET['date'];
//if (!isset($_GET['ask'])) $ask = ''; else $ask = $_GET['ask'];
if (!isset($_GET['next'])) $next = ''; else $next = $_GET['next'];
if (!isset($_GET['prev'])) $prev = ''; else $prev = $_GET['prev'];
if (!isset($_GET['id'])) $id = ''; else $id = $_GET['id'];
if (!isset($_GET['on'])) $on = ''; else $on = $_GET['on'];
if (!isset($_GET['override'])) $override = ''; else $override = $_GET['override'];

#initialize global template output $agendax
$agendax = array();

/* ----------------------------------------
** navbar at the top
*/
  
ob_start();

$m = date("n",$userTimestamp);
$y = date("Y",$userTimestamp);
$d = date("j",$userTimestamp);

echo "<!-- Agenda-X version $agd_version, Copyright Wang Jue (wjue) 2003, 2004 http://www.China-Offshore.com -->\n<div class=axNavbar>";

/*
** The unique id of an item to check permissions for.
*/
$perm_itemid = AGENDAX_PERM_SUBMIT;

/*
** check permission
** Specify the permission we are going to check for. This must be one of the permission names created on the admin side.
*/
$perm_name = 'Global Permission';

/*
** Get group ids that the current user belongs to.
*/
if ($xoopsUser) {
    $groups = $xoopsUser->getGroups();
} else {
    $groups = XOOPS_GROUP_ANONYMOUS;
}

/*
** Get the current module ID.
*/
$module_id = $xoopsModule->getVar('mid');

/*
** Get the group permission handler.
*/
$gperm_handler =& xoops_gethandler('groupperm');

if ($gperm_handler->checkRight($perm_name, $perm_itemid, $groups, $module_id)) {
  if ($op == "addevent") echo "<b>";
  if ($op == "eventform") echo "<b>";
  echo "<a href=$agendax_url/index.php?op=eventform>"._("Add event")."</a>";
  if ($op == "eventform") echo "</b>";
  if ($op == "addevent") echo "</b>";
  echo " $delimiter ";
}
 
  if ($op == "cats") echo "<b>";
  echo "<a href=$agendax_url/index.php?op=cats>"._("Categories")."</a>";
  if ($op == "cats") echo "</b>";
  
  if ($op == "day") echo "<b>";
  echo " $delimiter <a href=$agendax_url/index.php?op=day>"._("Day view")."</a>";
  if ($op == "day") echo "</b>";
  
  if ($op == "week") echo "<b>";
  echo " $delimiter <a href=$agendax_url/index.php?op=week>"._("Week view")."</a>";
  if ($op == "week") echo "</b>";
  
  if ($op == "cal") echo "<b>";
  echo " $delimiter <a href=$agendax_url/index.php?op=cal>"._("Month view")."</a>";
  if ($op == "cal") echo "</b>";
  
  if ($op == "flat") echo "<b>";
  echo " $delimiter <a href=$agendax_url/index.php?op=flat>"._("Flat view")."</a>";
  if ($op == "flat") echo "</b>";
  
//echo " $delimiter".'<a href="http://www.wjue.org/support/">'._("Support").'</a>';
# search

  if ($op == "search") echo "<b>";
  echo " $delimiter <a href=\"$agendax_url/index.php?op=search\">"._("Search")."</a>";
  if ($op == "search") echo "</b>";
  
echo "<br /><br/></div>\n";

$agendax['navbar'] = ob_get_contents();
ob_end_clean();

//text sanitisor
$myts =& MyTextSanitizer::getInstance();



?>